/*
 * This file is part of Skyward Hub.
 *
 * Skyward Hub is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Skyward Hub is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Skyward Hub. If not, see <https://www.gnu.org/licenses/>.
 *
 */

#include "ModuleInfo.h"

ModuleInfo::ModuleInfo() {}

ModuleInfo::ModuleInfo(const ModuleId &id, const QString &name)
{
    setId(id);
    setName(name);
}

ModuleInfo::ModuleInfo(const ModuleId &id, const QString &name,
                       ModuleCategory category)
    : ModuleInfo(id, name)
{
    setCategory(category);
}

ModuleId ModuleInfo::getId() const { return id; }

void ModuleInfo::setId(const ModuleId &value) { id = value; }

QString ModuleInfo::getModuleName() const { return name; }

void ModuleInfo::setName(const QString &value) { name = value; }

std::function<Module *()> ModuleInfo::getFactoryMethod() const
{
    return factoryMethod;
}

void ModuleInfo::setFactoryMethod(const std::function<Module *()> &value)
{
    factoryMethod = value;
}

ModuleCategory ModuleInfo::getModuleCategory() const { return category; }

void ModuleInfo::setCategory(const ModuleCategory &value) { category = value; }
